#!/usr/bin/perl

# This script reads a DTD like w3centities-f.ent and prints a list of
# all entities to the standard output. Every line contains one entity,
# first its name (including & and ;), then seperated by tabulator, the
# value.
# At the end, their is an additional line which indicates the length
# of the longest name encountered.

binmode STDOUT, ":encoding(UTF-8)";

$startSign = "&";
$endSign = ";";

open $dtd, "<w3centities-f.ent";

while ($line = <$dtd>) {
    if($line =~ /\<!ENTITY\s+(\w+)\s+"([^"]+)"\s*\>/) {
        $name = $1;
        $encoded_value = $2;
        # Decode the entites. This has to be done twice!
        $value = &decode_entities(&decode_entities($encoded_value)); 
        # Write output
        $key = $startSign . $name . $endSign;
        $max_length = length($key) if $max_length < length($key);
        print $key, "\t", $value, "\n";
    }
}

print "Maximal key length was $max_length";

sub decode_entities() {
    my $string = shift;
    $string =~ s/\&\#(x?)([0-9A-Fa-f]+);/chr ($1 ? hex $2 : $2)/ge;
    return $string;
}

